<app-page-title [heading]="heading" [subheading]="subheading" [icon]="icon">
    <button class="mx-1 btn-shadow btn btn-primary" [disabled]="nuevo" (click)="nuevoRegistro()" *ngIf="!data">
        <i class="fas fa-plus mr-2"></i>Nuevo
    </button>
    <button class="mx-1 btn-shadow btn btn-success" (click)="guardarRegistro()" [disabled]="myFormGroup.invalid">
        <i class="fas fa-save mr-2"></i>Guardar
    </button>
    <button class="mx-1 btn-shadow btn btn-danger" (click)="eliminarRegistro()" *ngIf="myFormGroup.value.ncte && !data">
        <i class="fas fa-trash mr-2"></i>Eliminar
    </button>
    <button class="mx-1 btn-shadow btn btn-warning" (click)="resetRegistro()" *ngIf="!data">
        <i class="fas fa-redo-alt mr-2"></i>Reiniciar
    </button>
    <!-- <button class="mx-1 btn-shadow btn btn-info" (click)="imprimirRegistro()" *ngIf="myFormGroup.value.ncte && !data">
        <i class="fas fa-print mr-2"></i>Imprimir
    </button> -->
    <button class="mx-1 btn-shadow btn btn-info" (click)="openModal(notasModal)" *ngIf="myFormGroup.value.ncte">
        <i class="fas fa-sticky-note mr-2"></i>Notas
    </button>
    <button class="mx-1 btn-shadow btn btn-info" (click)="openModal(detalleModal)" *ngIf="myFormGroup.value.ncte">
        <i class="fas fa-external-link-alt mr-2"></i> Detalle
    </button>
</app-page-title>

<div class="card">
    <div class="card-body">
        <form [formGroup]="myFormGroup">
            <div class="row">
                <div class="form-group col-sm-3 col-md-3 col-lg-3 col-xl-2">
                    <label>Propiedad</label>
                    <input type="text" tabindex="1" class="form-control" formControlName="propiedad" readonly>
                </div>
                <div class="form-group col-sm-3 col-md-3 col-lg-3 col-xl-2">
                    <label># Cliente</label>
                    <div class="input-group">
                        <input type="number" tabindex="2" class="form-control" formControlName="ncte" #cte
                            [readonly]="data" (change)="clienteChange(cte.value)">
                        <span class="input-group-append" *ngIf="!data">
                            <button (click)="openModal(historicoModal)" class="btn btn-info">
                                <i class="fas fa-search"></i>
                            </button>
                        </span>
                    </div>
                </div>
                <!-- <div class="form-group col-sm-3 col-md-3 col-lg-3 col-xl-3">
                    <label>Titulo</label>
                    <kendo-combobox formControlName="htitulo" [data]="dsTitulo" [textField]="'tdesc'"
                        [valueField]="'Titulo'" [valuePrimitive]="true" tabindex="3" class="w-100">
                    </kendo-combobox>
                </div> -->
                <div class="form-group col-sm-3 col-md-3 col-lg-3 col-xl-2">
                    <label>Fecha Alta</label>
                    <kendo-datepicker [format]="formatKendo" class="w-100" tabindex="4" formControlName="hfecalta"
                        readOnly>
                    </kendo-datepicker>
                </div>
                <div class="form-group col-sm-3 col-md-3 col-lg-3 col-xl-3">
                    <label>Apellidos(s)</label>
                    <input type="text" tabindex="5" class="form-control" formControlName="hapellido" appFocus>
                </div>
                <div class="form-group col-sm-3 col-md-3 col-lg-3 col-xl-3">
                    <label>Nombre(s)</label>
                    <input type="text" tabindex="6" class="form-control" formControlName="hnombre">
                </div>
                <div class="form-group col-sm-3 col-md-3 col-lg-3 col-xl-2">
                    <label>Dirección 1</label>
                    <input type="text" tabindex="7" class="form-control" name="direccion1"
                        [ngModelOptions]="{standalone: true}" [(ngModel)]="direccion1">
                </div>
                <div class="form-group col-sm-3 col-md-3 col-lg-3 col-xl-2">
                    <label>Dirección 2</label>
                    <input type="text" tabindex="8" class="form-control" name="direccion2" [(ngModel)]="direccion2"
                        [ngModelOptions]="{standalone: true}">
                </div>
                <div class="form-group col-sm-4 col-md-3 col-lg-3 col-xl-2">
                    <label>Ciudad</label>
                    <input type="text" tabindex="9" class="form-control" formControlName="hciudad">
                </div>
                <div class="form-group col-sm-4 col-md-3 col-lg-3 col-xl-2">
                    <label>Estado</label>
                    <div class="input-group">
                        <input type="text" tabindex="10" class="form-control" formControlName="estado">
                        <span class="input-group-append">
                            <button (click)="openModal(estadoModal)" class="btn btn-info">
                                <i class="fas fa-search"></i>
                            </button>
                        </span>
                    </div>
                </div>
                <!-- <div class="form-group col-sm-3 col-md-3 col-lg-2 col-xl-1">
                    <label>Pais</label>
                    <input type="text" class="form-control-plaintext" name="pais" formControlName="etice49" [(ngModel)]="pais">
                </div> -->
                <div class="form-group col-sm-4 col-md-3 col-lg-3 col-xl-2">
                    <label>C.P.</label>
                    <input type="text" tabindex="11" class="form-control" formControlName="hcp">
                </div>
                <div class="form-group col-sm-4 col-md-3 col-lg-3 col-xl-2">
                    <label>Telefóno</label>
                    <input type="text" tabindex="12" class="form-control" formControlName="htelefono">
                </div>
                <div class="form-group col-sm-4 col-md-3 col-lg-3 col-xl-2">
                    <label>Puesto</label>
                    <input type="text" tabindex="13" class="form-control" formControlName="hpuesto">
                </div>
                <div class="form-group col-sm-5 col-md-4 col-lg-4 col-xl-2">
                    <label>Ocupación</label>
                    <kendo-combobox formControlName="ocupacion" [data]="dsOcupacion" [textField]="'odesc'"
                        [valueField]="'Ocupacion'" [valuePrimitive]="true" tabindex="14" class="w-100">
                    </kendo-combobox>
                </div>
                <div class="form-group col-sm-5 col-md-4 col-lg-4 col-xl-2">
                    <label>Estado Civil</label>
                    <kendo-combobox formControlName="ECivil" [data]="dsEstadoCivil" [textField]="'edesc'"
                        [valueField]="'Ecivil'" [valuePrimitive]="true" tabindex="15" class="w-100"></kendo-combobox>
                </div>
                <div class="form-group col-sm-4 col-md-3 col-lg-3 col-xl-2">
                    <label>Idioma</label>
                    <kendo-combobox formControlName="hidioma" [data]="dsIdioma" [textField]="'idesc'"
                        [valueField]="'Idioma'" [valuePrimitive]="true" tabindex="16" class="w-100" required>
                    </kendo-combobox>
                </div>
                <div class="form-group col-sm-5 col-md-4 col-lg-4 col-xl-4">
                    <label>Email</label>
                    <input type="text" tabindex="17" class="form-control" formControlName="hemail">
                </div>
                <div class="form-group col-sm-4 col-md-3 col-lg-3 col-xl-2">
                    <label>RFC Cía</label>
                    <div class="input-group">
                        <input type="text" tabindex="18" class="form-control" formControlName="rfc">
                        <span class="input-group-append">
                            <button (click)="openModal(rfcModal)" class="btn btn-info">
                                <i class="fas fa-search"></i>
                            </button>
                        </span>
                    </div>
                </div>
                <div class="form-group col-sm-6 col-md-5 col-lg-4 col-xl-2">
                    <label>Clasificación</label>
                    <kendo-combobox formControlName="clasif" [data]="dsClasif" [textField]="'cdesc'"
                        [valueField]="'clasif'" [valuePrimitive]="true" tabindex="19" class="w-100" required>
                    </kendo-combobox>
                </div>
                <div class="form-group col-sm-3 col-md-2 col-lg-2 col-xl-2">
                    <label class="w-100">Env. Correo</label>
                    <kendo-combobox formControlName="hecorreo" [data]="dsEnvCorreo" [textField]="'desc'"
                        [valueField]="'value'" [valuePrimitive]="true" tabindex="20" class="w-100">
                    </kendo-combobox>
                </div>
                <div class="form-group col-sm-4 col-md-3 col-lg-3 col-xl-2">
                    <label>Fec. Nac.</label>
                    <kendo-datepicker [format]="formatKendo" class="w-100" tabindex="21" formControlName="hfecnac">
                    </kendo-datepicker>
                </div>
                <div class="form-group col-sm-4 col-md-3 col-lg-3 col-xl-2">
                    <label>Aniv. Bodas</label>
                    <kendo-datepicker [format]="formatKendo" class="w-100" tabindex="22" formControlName="hfecaniv">
                    </kendo-datepicker>
                </div>
                <div class="form-group col-sm-4 col-md-3 col-lg-3 col-xl-2">
                    <label>Contrato</label>
                    <input type="text" tabindex="23" class="form-control" formControlName="contrato">
                </div>
                <div class="form-group col-sm-6 col-md-5 col-lg-4 col-xl-4">
                    <label>Req. Especial</label>
                    <input type="text" tabindex="24" class="form-control" formControlName="hreqesp">
                </div>
                <div class="form-group col-sm-4 col-md-3 col-lg-3 col-xl-1">
                    <label class="w-100">Inactivo</label>
                    <kendo-switch formControlName="Inactivo" [onLabel]="'Si'" [offLabel]="'No'">
                    </kendo-switch>
                </div>
            </div>

            <div class="divider"></div>

            <div class="row col-12 d-flex justify-content-between mt-3">
                <div class="form-group col-sm-3 col-md-2 col-lg-2 col-xl-1">
                    <label>Ult. F.P.</label>
                    <input type="text" class="form-control" formControlName="hfp" readonly>
                </div>
                <div class="form-group col-sm-6 col-md-5 col-lg-4 col-xl-4">
                    <label>Desc. F.P.</label>
                    <input type="text" class="form-control" formControlName="hdfp" readonly>
                </div>
                <div class="form-group col-sm-5 col-md-4 col-lg-4 col-xl-3">
                    <label>Vendedor</label>
                    <kendo-combobox formControlName="Vendedor" [data]="dsVendedores" [textField]="'vnombre'"
                        [valueField]="'Vendedor'" [valuePrimitive]="true" class="w-100" readonly></kendo-combobox>
                </div>
                <div class="form-group col-sm-4 col-md-3 col-lg-3 col-xl-2">
                    <label>Ultima Llegada</label>
                    <kendo-datepicker [format]="formatKendo" class="w-100" formControlName="hultfec" readonly>
                    </kendo-datepicker>
                </div>
                <div class="form-group col-sm-3 col-md-3 col-lg-2 col-xl-2">
                    <label>Llegadas</label>
                    <input type="text" class="form-control" formControlName="htllegadas" readonly>
                </div>
                <div class="form-group col-sm-3 col-md-3 col-lg-2 col-xl-2">
                    <label>Noches</label>
                    <input type="text" class="form-control" formControlName="htnoches" readonly>
                </div>
                <div class="form-group col-sm-3 col-md-3 col-lg-2 col-xl-2">
                    <label>No Shows</label>
                    <input type="text" class="form-control" formControlName="htnoshow" readonly>
                </div>
                <div class="form-group col-sm-3 col-md-3 col-lg-2 col-xl-2">
                    <label>Ing. Habitación</label>
                    <input type="text" class="form-control text-right" formControlName="hthab" readonly>
                </div>
                <div class="form-group col-sm-3 col-md-3 col-lg-2 col-xl-2">
                    <label>Ing. A & B</label>
                    <input type="text" class="form-control text-right" formControlName="htayb" readonly>
                </div>
                <div class="form-group col-sm-3 col-md-3 col-lg-2 col-xl-2">
                    <label>Ing. Otros</label>
                    <input type="text" class="form-control text-right" formControlName="htotros" readonly>
                </div>
            </div>
        </form>
    </div>
</div>


<ng-template #detalleModal let-c="close" let-d="dismiss" let-modal>
    <div class="modal-header">
        <h6 class="modal-title" id="modal-chart">Detalle del Cliente</h6>
        <button class="close" aria-label="Close" (click)="modal.dismiss()">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
    <div class="modal-body">
        <app-detalle-cliente [data]="dsHistdet" [resumen]="dsResumenCte"></app-detalle-cliente>
    </div>
    <div class="modal-footer">
        <button class="btn btn-secondary" (click)="c()">Cerrar</button>
    </div>
</ng-template>

<ng-template #historicoModal let-c="close" let-d="dismiss" let-modal>
    <div class="modal-header">
        <h6 class="modal-title" id="modal-chart">Historico de Clientes</h6>
        <button class="close" aria-label="Close" (click)="modal.dismiss()">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
    <div class="modal-body">
        <app-buscar-clientes (result)="clienteChange($event.ncte); c()">
        </app-buscar-clientes>
    </div>
    <div class="modal-footer">
        <button class="btn btn-secondary"></button>
    </div>
</ng-template>

<ng-template #estadoModal let-c="close" let-d="dismiss" let-modal>
    <div class="modal-header">
        <h6 class="modal-title">Estados</h6>
        <button class="close" aria-label="Close" (click)="modal.dismiss()">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
    <div class="modal-body">
        <app-help-estado (estado)="resultEstado($event); c()"></app-help-estado>
    </div>
    <div class="modal-footer">
        <button class="btn btn-secondary" (click)="c()">
            Cerrar
        </button>
    </div>
</ng-template>

<ng-template #notasModal let-c="close" let-d="dismiss" let-modal>
    <div class="modal-header">
        <h6 class="modal-title">Notas para el cliente</h6>
        <button class="close" aria-label="Close" (click)="modal.dismiss()">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
    <div class="modal-body">
        <app-notas [cliente]="myFormGroup.value.ncte" [notas]="dsNotas" [tipos]="dsTipoNotas"
            (resultNotas)="resultNotas($event)"></app-notas>
    </div>
    <div class="modal-footer">
        <button class="btn btn-secondary" (click)="c()">
            Cerrar
        </button>
    </div>
</ng-template>

<ng-template #rfcModal let-c="close" let-d="dismiss" let-modal>
    <div class="modal-header">
        <h6 class="modal-title">Buscar Razón Social</h6>
        <button class="close" aria-label="Close" (click)="modal.dismiss()">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
    <div class="modal-body">
        <app-help-rfc (rfc)="resultRfc($event); c()"></app-help-rfc>
    </div>
    <div class="modal-footer">
        <button class="btn btn-secondary" (click)="c()">
            Cerrar
        </button>
    </div>
</ng-template>